/*

delta.c

(C) 1997 lars brinkhoff

1997-12-30: Hacked up in a few hours.  Really neeads some cleaning up
            and a sound theroy behind it.  Seems to work, though.
*/

#include <stdio.h>
#include <stdlib.h>

struct Options
{
  int N;
};

void parse_options (int, char *[], struct Options *);

void
move_cursor (int x, int y)
{
  printf ("\033[%d;%dH", y, x);			/* VT100 */
//  printf ("\033Y%c%c", y + 32, x + 32);	/* VT52 */
}

extern char *optarg;
extern int optind;

int
main (int argc, char *argv[])
{
  FILE *f1, *f2;
  char c1, c2;
  int x = 1, y = 1;
  char *s;
  int t = 0;
  int first = 1;
  int oldx = 1, oldy = 1;
  struct Options options;

  parse_options (argc, argv, &options);
  
  s = malloc (options.N);
  if (s == 0)
    {
      printf ("%s: out of memory\n", argv[0]);
      exit (1);
    }

  f1 = fopen (argv[optind], "r");
  if (f1 == 0)
    {
      fprintf (stderr, "%s: couldn't open file %s\n", argv[0], argv[optind]);
      exit (1);
    }

  f2 = fopen (argv[optind + 1], "r");
  if (f2 == 0)
    {
      fprintf (stderr, "%s: couldn't open file %s\n", argv[0],
	       argv[optind + 1]);
      exit (1);
    }

  while (!feof (f1))
    {
      c1 = fgetc (f1);
      c2 = fgetc (f2);

#if 0 /* simplified algorithm */
      if (c1 == c2)
	/* do nothing */
	;
      else
	{
	  move_cursor (x, y);
	  putchar (c2);
	}
#else /* complicated algorithm */
      if (c1 == c2)
	{
	  /* Input equal.  Output nothing, but save for later use. */
	  if (t < options.N)
	    s[t++] = c2;
	  if (t == 1)
	    {
	      oldx = x;
	      oldy = y;
	    }
	}
      else
	{
	  /* Input different.  Output something now. */
	  
	  if (t == 0)
	    {
	      /* Previous character was different. */
	      if (first)
		move_cursor (x, y);
	      putchar (c2);
	    }
	  else if (t < options.N)
	    {
	      /* The previous few characters were same, but since a
		 move cursor sequence is expensive, we output the
		 characters anyway. */
	      int i;

	      if (first)
		move_cursor (oldx, oldy);
	      for (i = 0; i < t; i++)
		putchar (s[i]);
	      putchar (c2);
	    }
	  else
	    {
	      /* Many previous charcters were same, so emit a move
		 cursor sequence. */
	      move_cursor (x, y);
	      putchar (c2);
	    }
	  first = 0;
	  t = 0;
	}
#endif
      if (c2 == '\n')
	{
	  x = 1;
	  y++;
	}
      else
	x++;
    }

  return 0;
}

void
parse_options (int argc, char *argv[], struct Options *options)
{ 
  int c;

  /* Defaults. */
  options->N = 8;	/* Empirical tests has shown a value
			   of 8 or 9 to be optimal. */
  
  while ((c = getopt (argc, argv, "N:")) != EOF)
    switch (c)
      {
      case 'N': options->N = atoi (optarg); break;
      }

  if (argc - optind != 2)
    {
      fprintf (stderr, "%s: must give exactly two file names\n",
	       argv[0]);
      exit (1);
    }
}
